#!/bin/bash
for USER in $(who | awk '{print $1}' | sort | uniq);do
  #USER_NAME=$(who | grep tty | awk '{print $1}' | sort | uniq | head -n 1)
  USER_NAME=$USER
  USER_ID=$(id -u "$USER_NAME")
  CARD_PATH="/sys/class/drm/card0/"
  AUDIO_OUTPUT="analog-surround-40"
  PULSE_SERVER="unix:/run/user/"$USER_ID"/pulse/native"
  CARD_ID=5
  FIND_STR=" HDMI"
  FIND_STR1="Intel Corporation"
  #FIND_STR1="HP-HPP"
  include_flag=0
  NEED_SET=false 
 
  for OUTPUT in $(cd "$CARD_PATH" && echo card*); do
    OUT_STATUS=$(<"$CARD_PATH"/"$OUTPUT"/status)
    echo $OUTPUT $OUT_STATUS	
    if [[ $OUT_STATUS == connected ]]; then
      echo $OUTPUT connected
      case "$OUTPUT" in
        "card0-HDMI-A-1")
	  AUDIO_OUTPUT="hdmi-stereo" # Digital Stereo (HDMI 1)
	  ;;
	"card0-HDMI-A-2")
	  AUDIO_OUTPUT="hdmi-stereo-extra1" # Digital Stereo (HDMI 2)
	  ;;
	esac
    elif [[ $OUT_STATUS == disconnected ]]; then
      case "$OUTPUT" in
        "card0-HDMI-A-1")   
#	  AUDIO_OUTPUT="off"
          ;;
	"card0-HDMI-A-2")
#	  AUDIO_OUTPUT="off"
	  ;;
        esac
    fi
  done

  sudo -H -u ${USER_NAME} echo 'HDMI 状态更改' $USER_NAME >> /tmp/kylin_hdmi_sound_toggle.log
  sudo -H -u ${USER_NAME} echo selecting output $AUDIO_OUTPUT $OUT_STATUS >> /tmp/kylin_hdmi_sound_toggle.log
  sudo -H -u ${USER_NAME} pactl --server $PULSE_SERVER list cards > /tmp/kylin_hdmi_sound_toggle.tmp
  #找到声卡标识为HDMI的index
  while read line;do
    case $line in
      卡*)
        index="$line"
	include_flag=1
	;;
      端口*)
      # echo ports
      index=
      include_flag=0
      ;;
      *)
	if [[ $line =~ $FIND_STR ]] && [ $include_flag -eq 1 ];then
	  if [ -n "$index" ];then
	    CARD_ID=${index#卡 #}
            NEED_SET=true
            echo "cardid 为"  $CARD_ID >> /tmp/kylin_hdmi_sound_toggle.log 
	  fi
	elif [[ $line =~ $FIND_STR1 ]] && [ $include_flag -eq 1 ];then
          if [ -n "$index" ];then
            CARD_ID=${index#卡 #}
            NEED_SET=true
            echo "find card id :" $CARD_ID
            echo "cardid 为"  $CARD_ID >> /tmp/kylin_hdmi_sound_toggle.log
          fi   
        fi
      ;;
    esac
  done < /tmp/kylin_hdmi_sound_toggle.tmp 
  echo "CARD_ID =====" $CARD_ID $NEED_SET $AUDIO_OUTPUT
  if [[ $NEED_SET == false ]];then
    exit -1
  fi

  if [[ $AUDIO_OUTPUT == off ]];then
    #sudo -H -u ${USER_NAME} pactl --server $PULSE_SERVER set-card-profile $CARD_ID off	
    echo "hdmi 声卡已拔出，设置配置文件为off" $USER_NAME $CARD_ID >> /tmp/kylin_hdmi_sound_toggle.log 
  else 
    sudo -H -u ${USER_NAME} pactl --server $PULSE_SERVER set-default-sink alsa_output.pci-0000_00_1f.3-platform-skl_hda_dsp_generic.HiFi__hw_sofhdadsp_4__sink
    sudo -H -u ${USER_NAME} pactl --server $PULSE_SERVER set-card-profile alsa_card.pci-0000_00_1f.3 output:hdmi-stereo-extra1+input:analog-stereo
    echo "设置对应的HDMI输出"
    #sudo -H -u ${USER_NAME} pactl --server $PULSE_SERVER set-card-profile $CARD_ID output:$AUDIO_OUTPUT
    echo "hdmi 插入，将hdmi设置为默认的声卡" $AUDIO_OUTPUT $USER_NAME  $CARD_ID >> /tmp/kylin_hdmi_sound_toggle.log
  fi
done

rm -rf /tmp/kylin_hdmi_sound_toggle.log
rm -rf /tmp/kylin_hdmi_sound_toggle.tmp
